VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Musikplayer"
   ClientHeight    =   2265
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   5400
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2265
   ScaleWidth      =   5400
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSave 
      Caption         =   "Melodie speichern"
      Height          =   375
      Left            =   3480
      TabIndex        =   13
      Top             =   1200
      Width           =   1815
   End
   Begin VB.CommandButton cmdLoadMelody 
      Caption         =   "Melodie laden"
      Height          =   375
      Left            =   3480
      TabIndex        =   12
      Top             =   1680
      Width           =   1815
   End
   Begin VB.Frame Frame1 
      Caption         =   "Einstellungen"
      Height          =   2055
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   3255
      Begin VB.TextBox txtPause 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   1440
         TabIndex        =   11
         Text            =   "50"
         Top             =   1680
         Width           =   1695
      End
      Begin VB.TextBox txtDuration 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   1440
         TabIndex        =   10
         Text            =   "50"
         Top             =   1320
         Width           =   1695
      End
      Begin VB.TextBox txtSeed 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   1440
         TabIndex        =   9
         Text            =   "-1"
         Top             =   960
         Width           =   1695
      End
      Begin VB.TextBox txtMaxFreq 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   1440
         TabIndex        =   8
         Text            =   "2500"
         Top             =   600
         Width           =   1695
      End
      Begin VB.TextBox txtMinFreq 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   1440
         TabIndex        =   7
         Text            =   "0"
         Top             =   240
         Width           =   1695
      End
      Begin VB.Label Label5 
         Caption         =   "Seed:"
         Height          =   255
         Left            =   120
         TabIndex        =   6
         Top             =   960
         Width           =   1095
      End
      Begin VB.Label Label4 
         Caption         =   "Pause:"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   1680
         Width           =   1095
      End
      Begin VB.Label Label3 
         Caption         =   "Dauer:"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   1320
         Width           =   1215
      End
      Begin VB.Label Label2 
         Caption         =   "Max. Frequenz:"
         Height          =   255
         Left            =   120
         TabIndex        =   3
         Top             =   600
         Width           =   1215
      End
      Begin VB.Label Label1 
         Caption         =   "Min. Frequenz:"
         Height          =   255
         Left            =   120
         TabIndex        =   2
         Top             =   240
         Width           =   1095
      End
   End
   Begin MSComDlg.CommonDialog  
      Left            =   3480
      Top             =   720
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Timer tmrPlay 
      Enabled         =   0   'False
      Interval        =   75
      Left            =   4080
      Top             =   600
   End
   Begin VB.CommandButton cmdPlayMelody 
      Caption         =   "Melodie spielen"
      Height          =   375
      Left            =   3480
      TabIndex        =   0
      Top             =   360
      Width           =   1815
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Private Variablen
Private IsRunning As Boolean
Private FreqDiff As Long
Private MinFreq As Long
Private Duration As Long
Private Freq As Long

' API-Deklaration (Beep - spielt einen Sound mit bestimmter Frequenz und Dauer)
Private Declare Function Beep Lib "kernel32" (ByVal dwFreq As Long, ByVal dwDuration As Long) As Long

' Ldt eine Melodie aus einer Datei
Private Sub cmdLoadMelody_Click()
   Dim tmpStr As String
   
   With 
      ' Dialog-Titel setzen
      .DialogTitle = "Melodie ffnen..."
      ' Dateifilter setzen (nur .mdy-Dateien anzeigen)
      .Filter = "Melodie-Dateien (*.mdy))|*.mdy"
      ' ffnen-Dialog anzeigen
      Call .ShowOpen
      
      ' Wurde eine Datei ausgewhlt? Wenn nein, Prozedur verlassen
      If .FileName = "" Then Exit Sub
      
      ' Gewhlte Datei ffnen
      Open .FileName For Input As #1
         ' Minimale Frequenz einlesen
         Line Input #1, tmpStr
         txtMinFreq.Text = tmpStr
         
         ' Maximale Frequenz einlesen
         Line Input #1, tmpStr
         txtMaxFreq.Text = tmpStr
         
         ' Seed einlesen
         Line Input #1, tmpStr
         txtSeed.Text = tmpStr
         
         ' Dauer eines Tons einlesen
         Line Input #1, tmpStr
         txtDuration.Text = tmpStr
         
         ' Pause zwischen zwei Tnen einlesen
         Line Input #1, tmpStr
         txtPause.Text = tmpStr
         
      ' Datei wieder schlieen
      Close #1
   End With
End Sub

Private Sub cmdPlayMelody_Click()
   ' Wird grade eine Melodie gespielt?
   If Not IsRunning Then
      ' Nein - Neue Melodie initialisieren
      
      ' Wurden gltige Werte eingegeben?
      If Not IsNumeric(txtMinFreq.Text) Or Not IsNumeric(txtMaxFreq.Text) Or Not IsNumeric(txtSeed.Text) Or _
         Not IsNumeric(txtDuration.Text) Or Not IsNumeric(txtDuration.Text) Then
         
         ' Nein - Fehlermeldung ausgeben
         Call MsgBox("Es wurden ungltige Werte eingegeben!", vbExclamation, "Numerische Werte bentigt")
         
         ' Prozedur verlassen
         Exit Sub
      End If
      
      ' Es wird nun eine Melodie gespielt
      IsRunning = True
      
      ' Differenz zwischen hchstem und tiefstem Ton berechnen
      FreqDiff = CLng(txtMaxFreq.Text) - CLng(txtMinFreq.Text)
      ' Minimale Frequenz und Dauer eines Tons einlesen
      MinFreq = CLng(txtMinFreq.Text)
      Duration = CLng(txtDuration.Text)
      
      ' Pause zwischen zwei Tnen einlesen
      tmrPlay.Interval = CLng(txtPause.Text)
      
      ' Wurde ein Seed eingegeben?
      If CLng(txtSeed.Text) <> -1 Then
         ' Ja - Zufallsgenerator zurcksetzen
         Call Rnd(-1)
         ' Zufallsgenerator initialisieren
         Call Randomize(CLng(txtSeed.Text))
      End If
      
      ' Timer aktivieren
      tmrPlay.Enabled = True
      
      ' Beschriftung ndern
      cmdPlayMelody.Caption = "Melodie anhalten"
   Else
      ' Ja - Melodie anhalten
      ' Es wird keine Melodie mehr abgespielt
      IsRunning = False
      ' Timer deaktivieren
      tmrPlay.Enabled = False
      
      ' Beschriftung des Fensters ndern
      Me.Caption = "Musikplayer"
      ' Beschriftung ndern
      cmdPlayMelody.Caption = "Melodie spielen"
   End If
End Sub

Private Sub cmdSave_Click()
   With 
      ' Dialog-Titel setzen
      .DialogTitle = "Melodie speichern unter..."
      ' Datei-Filter setzen (siehe cmdLoadMelody_Click() )
      .Filter = "Melodie-Dateien (*.mdy))|*.mdy"
      ' Speichern-Dialog anzeigen
      Call .ShowSave
      
      ' Wurde eine Datei ausgewhlt? Wenn nein, Prozedur beenden
      If .FileName = "" Then Exit Sub
      
      ' Gewhlte Datei ffnen
      Open .FileName For Output As #1
         ' Minimale Frequenz speichern
         Print #1, txtMinFreq.Text
         ' Maximale Frequenz speichern
         Print #1, txtMaxFreq.Text
         ' Seed speichern
         Print #1, txtSeed.Text
         ' Dauer eines Tons speichern
         Print #1, txtDuration.Text
         ' Pause zwischen zwei Tnen speichern
         Print #1, txtPause.Text
         
      ' Datei wieder schlieen
      Close #1
      
      ' Meldung ausgeben, dass die Datei gespeichert wurde
      Call MsgBox("Datei wurde unter " & .FileName & " gespeichert.", vbInformation, "Datei gespeichert")
   End With
End Sub

Private Sub tmrPlay_Timer()
   ' Frequenz berechnen - die Frequenz ist grer/gleich MinFreq und kleiner/gleich MinFreq + FreqDiff
   Freq = Rnd() * FreqDiff + MinFreq
   ' Ton abspielen
   Call Beep(Freq, Duration)
   
   ' Beschriftung des Fensters setzen
   Me.Caption = "Musikplayer - " & CStr(Freq) & "Hz"
End Sub
